<?php
/*
	WPGear.
	GV Excel Export PRO
	admin.php
*/

	/* MetaBox. Add to GV admin forms.
	----------------------------------------------------------------- */
	function GVXLPro_Add_Metaboxes_GV () {		
		$screens = array( 'gravityview');	
			
		// Excel-Export.
		add_meta_box( 'GVXL_ExcelExport_Metabox', 'Excel-Export.', 'GVXLPro_Add_ExcelExport_Metabox_Callback', $screens, 'side', 'high');		

        // AdministratorView options.
		add_meta_box( 'GVXL_AdministratorView_metabox', 'Administrator View.', 'GVXLPro_Add_AdministratorView_metabox_callback', $screens, 'side', 'high');
	}
	add_action('add_meta_boxes', 'GVXLPro_Add_Metaboxes_GV');	  
	
	/* MetaBox Excel-Export.
	----------------------------------------------------------------- */	
	function GVXLPro_Add_ExcelExport_Metabox_Callback ($post, $meta) {	
		$GV_Settings = get_option('gravityformsaddon_gravityview_app_settings', array());
		
		$GV_Settings_ExcelExport 	= isset($GV_Settings['excel-export']) ? intval($GV_Settings['excel-export']) : true;
		$Action 					= isset($_REQUEST['action']) ? sanitize_text_field($_REQUEST['action']) : null;
	
		$PostID = $post->ID;
		
		if ($PostID && $Action == 'edit') {
			global $GVXLPro_plugin_url;
			
			$key = 'gvxl_excel-export_control';
			$ExcelExport_Control = get_post_meta( $PostID, $key, true );
		
			if ($GV_Settings_ExcelExport) {
				if ($ExcelExport_Control) {
					?>
					<script src="<?php echo $GVXLPro_plugin_url .'includes/admin_fields_control.js'; ?>"></script>
					<?php
				}

				?>
                <link rel="stylesheet" href="<?php echo $GVXLPro_plugin_url .'style.css'; ?>">
				<div class='gvxl_metabox'>
					<div>
						<div>
							<label>
								<input id="gvxl_excelexport" type="checkbox" name="gvxl_excelexport" onchange="excelexport_info()" <?php if ($ExcelExport_Control) {echo 'checked="checked"';} ?> value="1" />
								<span class='gvxl_metabox_excelexport_title' title="Enable 'Excel-Export' for this form.">
									Excel-Export <i class="fa fa-info-circle" aria-hidden="true"></i>
								</span>
							</label>					
						</div>
						<div id="excelexport_info_box" class="gvxl_excelexport_info_box" style="display: none;">
							you need to update this form, before changes to take effect.
						</div>				
					</div>
				</div>

				<script>
					function excelexport_info () {
						document.getElementById('excelexport_info_box').style.display = 'block';
					}
				</script>
				<?php				
				// Some Problems about - Try Register Script for GV Admin page!
			} else {
				// Excel-Export - Disabled on GV Settings.
				?>
				<div class='gvxl_metabox'>
					<div>
						<div class="gvxl_metabox_disabled">
							<label>
								<input id="gvxl_excelexport" type="checkbox" name="gvxl_excelexport" <?php if ($ExcelExport_Control) {echo 'checked="checked"';} ?> value="1" />
								<span class='gvxl_metabox_excelexport_title' title="Enable 'Excel-Export' for this form.">
									Excel-Export <i class="fa fa-info-circle" aria-hidden="true"></i>
								</span>
							</label>					
						</div>					
						<div id="excelexport_info_box" class="gvxl_excelexport_info_box">
							Disabled on GV Settings.
						</div>				
					</div>
				</div>
				<?php				
			}				
		} 
	}

	/* MetaBox AdministratorView.
	----------------------------------------------------------------- */  
	function GVXLPro_Add_AdministratorView_metabox_callback ($post, $meta) {		
		global $GVXLPro_plugin_url;
		
		$PostID = $post->ID;	
		
		$key = 'gvxl_filter_admin_control';
		$Filter_Admin_Control = get_post_meta( $PostID, $key, true );	

		// Используем nonce для верификации
		wp_nonce_field( plugin_basename(__FILE__), 'GVXLPro_nonce_filter' );        		

		// Поля формы для введения данных
		?>
		<link rel="stylesheet" href="<?php echo $GVXLPro_plugin_url .'style.css'; ?>">
		<div class='gvxl_metabox'>
			<div>
				<div>
					Show all records (Frontend & Excel-Export) if current user:
				</div>

				<div>
					<label>
						<input id="gvxl_filter_admin" type="checkbox" name="gvxl_filter_admin" <?php if ($Filter_Admin_Control) {echo 'checked="checked"';} ?> value="1" />
						<span class='gvxl_metabox_access_title' title="Show all records of all Users, if the current user is Administrator (defined by the Role).">
							Administrator <i class="fa fa-info-circle" aria-hidden="true"></i>
						</span>
					</label>					
				</div>

				<div style="margin-top: 20px; font-size: small; color: grey;">
					*Need to install: 'GravityView Advanced Filter'. And set: [created by - is - Currently Logged-in User]
				</div>                				
			</div>
		</div>
		<?php				
	}      	

	/* MetaBox. Save options whith GV.
	----------------------------------------------------------------- */	
	function GVXLPro_Metabox_Filters_Save( $post_id ) {		
		// Autosave, Do Nothing
		if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) 
			return;

		if( ! current_user_can( 'edit_post', $post_id ) ) {
			return;
		}

		// проверяем nonce нашей страницы, потому что save_post может быть вызван с другого места.
		if ( ! wp_verify_nonce( $_POST['GVXLPro_nonce_filter'], plugin_basename(__FILE__) ) ) {
			return;
		}        			

		// ОК. Do Save.
		$ExcelExport_Control    = isset($_POST['gvxl_excelexport']) ? intval($_POST['gvxl_excelexport']) : 0;
        $Filter_Admin_Control   = isset($_POST['gvxl_filter_admin']) ? intval($_POST['gvxl_filter_admin']) : 0;	

		$key = 'gvxl_excel-export_control';		
		update_post_meta( $post_id, $key, $ExcelExport_Control );

		$key = 'gvxl_filter_admin_control';
		update_post_meta( $post_id, $key, $Filter_Admin_Control );        
	}
	add_action( 'save_post_gravityview', 'GVXLPro_Metabox_Filters_Save' );	