<?php
/*
	WPGear.
	GV Excel Export PRO
	class-gravityview-widget-excel.php
 */
 
    class GravityView_Widget_Excel extends \GV\Widget {
	/* 
	 * Widget to add ShortCode: [gvxlpro_button_excelexport] -> 'Excel Export Button'
	 * @since 1.5.4
	 * @extends GravityView_Widget
	 */ 		
        protected $show_on_single = false;

        function __construct() {
			//$GV_Settings = get_option('gravityformsaddon_gravityview_app_settings', array());
			//$GV_Settings_ExcelExport 	= isset($GV_Settings['excel-export']) ? intval($GV_Settings['excel-export']) : false;
	
            //$PostID     = isset($_REQUEST['post']) ? $_REQUEST['post'] : null;
			//$Action     = isset($_REQUEST['action']) ? $_REQUEST['action'] : null;

			// Попытка анализировать опции: $GV_Settings_ExcelExport & $ExcelExport_Control, чтобы отображать/скрывать этот Виджет - неудачны.
            // При открытии страницы в Админке GV происходит нескольцо циклов Запросов и $_REQUEST становится недостоверной для обработки.
            // Поэтому, данный Виджет всегда будет присутствовать в списке доступных GV Виджетов.

            $this->widget_description = __('Button for Export to Excel', 'gravityview' );

            $default_values = array(
                'header' => 1,
                'footer' => 1,
            );

            $settings = array(
                'content' => array(
                    'type' => 'textarea',
                    'label' => __( 'Excel Export Button', 'gravityview' ),
                    'desc' => __( 'Button for Export to Excel.', 'gravityview' ),
                    'value' => '[gvxlpro_button_excelexport]',
                    'class'	=> 'code',
                    'merge_tags' => false,
                    'show_all_fields' => true,
                ),
            );

            parent::__construct( __( 'Excel Export Button', 'gravityview' ) , 'excel', $default_values, $settings );
        }

        public function render_frontend( $widget_args, $content = '', $context = '') {

            if( !$this->pre_render_frontend() ) {
                return;
            }

            if( !empty( $widget_args['title'] ) ) {
                echo $widget_args['title'];
            }


            // Make sure the class is loaded in DataTables
            if( !class_exists( 'GFFormDisplay' ) ) {
                include_once( GFCommon::get_base_path() . '/form_display.php' );
            }

            $widget_args['content'] = trim( rtrim( $widget_args['content'] ) );

            // No custom content
            if( empty( $widget_args['content'] ) ) {
                gravityview()->log->debug( 'No content.' );
                return;
            }

            // Add paragraphs?
            if( !empty( $widget_args['wpautop'] ) ) {
                $widget_args['content'] = wpautop( $widget_args['content'] );
            }

            $content = $widget_args['content'];

            $content = GravityView_Merge_Tags::replace_variables( $content, array(), array(), false, true, false );

            // Enqueue scripts needed for Gravity Form display, if form shortcode exists.
            // Also runs `do_shortcode()`
            $content = GFCommon::gform_do_shortcode( $content );


            // Add custom class
            $class = !empty( $widget_args['custom_class'] ) ? $widget_args['custom_class'] : '';
            $class = gravityview_sanitize_html_class( $class );

            echo '<div class="gv-widget-custom-content '.$class.'">'. $content .'</div>';

        }

    }

    new GravityView_Widget_Excel;